import React, { useMemo } from 'react';
import { StyleSheet, Text, View } from 'react-native';
import { EMPTY_ACTION, width } from '../../common/constants';
export const BoxDigit = _ref => {
  let {
    isValueFocused,
    handleOnPress,
    digit,
    pinCount,
    boxSelectedStyle,
    boxStyle,
    digitStyle,
    variant
  } = _ref;
  const selectedStyle = useMemo(() => boxSelectedStyle || {
    borderColor: 'blue'
  }, [boxSelectedStyle]);
  const renderDigitByVariant = useMemo(() => {
    return {
      default: /*#__PURE__*/React.createElement(View, {
        style: [styles.box, {
          width: (width - 40 - 20 * (pinCount - 1)) / pinCount
        }, boxStyle, isValueFocused ? selectedStyle : {}],
        onStartShouldSetResponder: EMPTY_ACTION,
        onResponderGrant: handleOnPress
      }, /*#__PURE__*/React.createElement(Text, {
        style: [styles.digit, digitStyle]
      }, digit)),
      security: /*#__PURE__*/React.createElement(View, {
        onStartShouldSetResponder: EMPTY_ACTION,
        onResponderGrant: handleOnPress
      }, /*#__PURE__*/React.createElement(View, {
        style: [styles.itemSecurity,
        // eslint-disable-next-line react-native/no-inline-styles
        digit !== null && digit !== void 0 && digit.length ? {
          backgroundColor: 'blue',
          borderWidth: 0
        } : {}, boxStyle,
        // eslint-disable-next-line react-native/no-inline-styles
        isValueFocused ? boxSelectedStyle || {
          borderColor: 'blue'
        } : {}]
      })),
      underlined: /*#__PURE__*/React.createElement(View, {
        style: styles.containerUnderLined,
        onStartShouldSetResponder: EMPTY_ACTION,
        onResponderGrant: handleOnPress
      }, /*#__PURE__*/React.createElement(View, {
        style: [digit !== null && digit !== void 0 && digit.length ? {} : styles.hidden]
      }, /*#__PURE__*/React.createElement(Text, {
        style: [styles.digit, digitStyle]
      }, digit || 0)), /*#__PURE__*/React.createElement(View, {
        style: [styles.itemUnderLined, isValueFocused ?
        // eslint-disable-next-line react-native/no-inline-styles
        boxSelectedStyle || {
          backgroundColor: 'blue'
        } : {}]
      }))
    };
  }, [boxSelectedStyle, boxStyle, digit, digitStyle, handleOnPress, isValueFocused, pinCount, selectedStyle]);
  return renderDigitByVariant[variant];
};
const styles = StyleSheet.create({
  boxContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    paddingHorizontal: 20
  },
  box: {
    height: 64,
    maxWidth: 56,
    borderWidth: 1,
    borderColor: 'black',
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: '#c3c3c3'
  },
  digit: {
    fontSize: 36,
    color: 'black'
  },
  itemSecurity: {
    height: 30,
    width: 30,
    borderRadius: 15,
    borderWidth: 2,
    borderColor: 'black'
  },
  itemUnderLined: {
    height: 3,
    width: 30,
    backgroundColor: 'gray'
  },
  containerUnderLined: {
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  hidden: {
    opacity: 0
  }
});
//# sourceMappingURL=index.js.map